# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#	Bonbon's Mug Cash script requested by Celine 			  #
#	Requires:									  #
#		Eventscripts 2.0							  #
#		ES_Tools								  #  
#											  #
#	add the line es_load bmug to your autoexec.cfg			  #
#											  #
#	Thank you to:								  #
#			Celine who had the idea for this			  #
#			Venjax who it was inspired by and fixed the crash  #
#			SuperDave see Venjax + more :P
#											  #
#	If you have any questions e-mail me at:				  #
#	drunkenmousehide@hotmail.com					  #
#	or use the PMS on the eventscripts formums			  #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

import es, gamethread, playerlib

player_time = {}
player_prop = {}

es.ServerVar('bmug_version', 2.1, 'BMug By: Bonbon').makepublic()
### Start config ###
money_per_second = 100 # The amount of money a person can steal per second Default: 300
money_range = 300 # The range in which people can steal money from dead peoples Default: 300
money_time = 30 # The amount of time people can mug people Default: 30 NOTE: DO NOT PUT OVER 998!
spinning_props = 0 # If 1, the props will spin. This causes major lag though, I suggest you don't use it if your server has lots of people!
spinning_quality = 0 # either 0, 1 or 2 if your props are spinning, this is the quality it spins at I only recommend 2 for windows
### End Config ###
model_list = ['mdl', 'dx80.vtx', 'dx90.vtx', 'phy', 'sw.vtx', 'vvd', 'xbox.vtx']
material_list = ['vmt', 'vtf']
model_dir = 'models/extras/money/info_speech.'
material_dir = 'materials/models/extras/money/speech_info.'

def load():
	es.msg('#multi', '#green[#lightgreenBMUG#green]: Loaded')
	addstuffs0rz()

def unload():
	es.msg('#multi', '#green[#lightgreenBMUG#green]: Unloaded')

def round_start(event_var):
	es.msg('#multi', '#green[#lightgreenBMUG#green]: BMUG is active, when a person dies you have #lightgreen%s#green seconds to mug them!'%money_time)

def player_disconnect(event_var):
	global player_prop, player_time
	userid = event_var['userid']
	if player_time.has_key(userid): 
		del player_time[userid]
	if player_prop.has_key(userid): 
		del player_prop[userid]

def round_end(event_var):
	global player_time, player_prop
	for userid in playerlib.getUseridList('#all'):
		player_time[userid] = 999
		player_prop[userid] = 0

def player_death(event_var):
	global player_time
	global player_prop
	userid = event_var['userid']
	player = playerlib.getPlayer(userid)
	team = player.attributes['teamid']
	(x, y, z) = es.getplayerlocation(userid)
	new_z = z + 10
	angs = player.get('viewangle')
	es.server.queuecmd('es_xsetang %s 90 0 0'%userid)
	es.server.queuecmd('es_prop_dynamic_create %s extras/money/info_speech'%userid)
	gamethread.delayedname(0, 'setprop_%s'%userid, setprop, args=(userid, x, y, new_z))
	gamethread.delayedname(0.2, 'cashadd_%s'%userid, cashadd, args=(x, y, new_z, userid, team))
	es.ServerVar('cash_gets0rz').set(0)
	player_time[userid] = 0
	es.server.queuecmd('es_xsetang %s %s %s %s'%(userid, angs[0], angs[1], angs[2]))
	if spinning_props:
		gamethread.delayedname(0.2, 'spin_%s'%userid, spin_prop, (userid))

def setprop(userid, x, y, new_z):
	global player_prop
	player_prop[userid] = int(es.ServerVar('eventscripts_lastgive'))
	gamethread.delayed(0, es.server.queuecmd, 'est_entteleport %s %s %s %s'%(player_prop[userid], x, y, new_z))

def spin_prop(userid):
	global player_time
	if player_time[userid] <= money_time:
		if player_prop[userid]:
			b = es.getindexprop(int(player_prop[userid]), 'CPhysicsPropMultiplayer.baseclass.baseclass.baseclass.baseclass.m_angRotation').split(',')
			es.setindexprop(int(player_prop[userid]), 'CPhysicsPropMultiplayer.baseclass.baseclass.baseclass.baseclass.m_angRotation', '%s,%s,%s'%(int(float(b[0])), int(float(b[1])) + (25 - (spinning_quality * 5)) if int(float(b[1])) + (25 - (spinning_quality * 5)) <= 360 else 0, b[2]))
			gamethread.delayed(0.3 - float(spinning_quality / 10.0), spin_prop, (userid))

def cashadd(x, y, new_z, userid, team):
	t_users = playerlib.getUseridList('#t,#alive')
	ct_users = playerlib.getUseridList('#ct,#alive')
	global player_time, player_prop
	if player_time[userid] <= money_time:
		player_time[userid] += 1
		gamethread.delayedname(1, 'cashadd_%s'%userid, cashadd, args=(x, y, new_z, userid, team))
		if team == 3:
			es.server.queuecmd('nearcoord cash_gets0rz #alive#t %s %s %s %s %s %s "es playerset cashadd server_var(cash_gets0rz) %s;playerset cashadd %s -%s"'%(x, y, new_z, money_range, money_range, money_range, money_per_second, userid, money_per_second))
		elif team == 2:
			es.server.queuecmd('nearcoord cash_gets0rz #alive#ct %s %s %s %s %s %s "es playerset cashadd server_var(cash_gets0rz) %s;playerset cashadd %s -%s"'%(x, y, new_z, money_range, money_range, money_range, money_per_second, userid, money_per_second))
	elif player_time[userid] < 1000:
		for a in es.createentitylist():
			if str(player_prop[userid]) == str(a):
				es.server.queuecmd('es_xremove %s'%player_prop[userid])
				player_prop[userid] = 0

def addstuffs0rz():
	for model in model_list:
		es.stringtable('downloadables', model_dir + model)
	for material in material_list:
		es.stringtable('downloadables', material_dir + material)

def es_map_start(event_var):
	addstuffs0rz()

def player_spawn(ev):
	global player_prop
	player_prop[ev['userid']] = None